rem set CONFIG=Release

@echo off
echo ͻ
echo                   Starting Build of CRunTiny                                 
echo                                                                              
echo.

echo Detecting compiler version...
cl /nologo version.cpp > nul:
for /F "usebackq delims==" %%i IN (`version`) DO set VERS=%%i 
del version.exe version.obj

if %VERS%==1200 set COMPILER=VC6
if %VERS%==1300 set COMPILER=VC7
if %VERS%==1310 set COMPILER=VC7.1

echo COMPILER=%COMPILER%
pushd %~dp0..
set CRunTiny=%CD%
popd
echo CRunTiny=%CRunTiny%
echo.
echo.

set PLATFORM=Win32

setlocal
echo ͻ
echo                   Static Single-Threaded
set LINKAGE=Static
set THREADING=ST
nmake /nologo /f startup.mak %* && nmake /nologo /f makefile.mak %*
echo                   End of Static Single-Threaded
echo ͼ
endlocal

setlocal
echo ͻ
echo                   Static Multi-Threaded
set LINKAGE=Static
set THREADING=MT
nmake /nologo /f startup.mak %* && nmake /nologo /f makefile.mak %*
echo                   End of Static Multi-Threaded
echo ͼ
endlocal

setlocal
echo ͻ
echo                   Dynamic Multi-Threaded
set LINKAGE=Dynamic
set THREADING=MT
nmake /nologo /f startup.mak %* && nmake /nologo /f makefile.mak %*
echo                   End of Dynamic Multi-Threaded
echo ͼ
endlocal


echo.
echo                                                                              
echo                   Finished Build of CRunTiny                                 
echo ͼ
