#directories

INTDIR=$(CRUNTINY)\private\build\$(COMPILER)\$(PLATFORM)\$(LINKAGE)_$(THREADING)\$(CONFIG)
BINDIR=$(CRUNTINY)\public\bin
LIBDIR=$(CRUNTINY)\public\lib
LISTING_DIR=$(INTDIR)\Listings
BASENAME=CRunTiny.$(PLATFORM).$(COMPILER).$(THREADING)$(SUFFIX)


#common variables

!INCLUDE common_vars.mak


#compiler dependent variables

!INCLUDE compiler.mak


#tool flags

!IF "$(LINKAGE)"=="Dynamic"

DEFINES = $(DEFINES) /D_WINDLL

!ENDIF

DEFINES=$(DEFINES) /DCRUNTINY_INSIDE_CRT


#targets

!INCLUDE "targets.mak"

STARTUP_LIBRARY="$(INTDIR)\startup.lib"

!IF "$(LINKAGE)" == "Static"


LIBRARY="$(LIBDIR)\$(BASENAME).lib"

$(LIBRARY) : make_main_dirs $(OBJECTS) $(STARTUP_LIBRARY)
	@echo Archiving $(@F)
	$(AT)$(LIB) @<<
$(LIBFLAGS) /out:"$(LIBRARY)" 
$(OBJECTS)
$(STARTUP_LIBRARY)
<<
	
TARGET = $(LIBRARY)

make_main_dirs:
	@if not exist "$(INTDIR)"      echo Making: "$(INTDIR)"      && mkdir "$(INTDIR)"
	@if not exist "$(LIBDIR)"      echo Making: "$(LIBDIR)"      && mkdir "$(LIBDIR)"
	@if not exist "$(LISTING_DIR)" echo Making: "$(LISTING_DIR)" && mkdir "$(LISTING_DIR)"

!ELSE

DLL="$(BINDIR)\$(BASENAME).dll"
LIBRARY="$(LIBDIR)\$(BASENAME).dll.lib"

$(DLL) : make_main_dirs $(OBJECTS) $(RESOURCES)
	@echo Linking $(@F)
	$(AT)$(LINK) @<<
$(LINKFLAGS) /out:"$(DLL)" /implib:"$(LIBRARY)" 
$(OBJECTS) 
$(LIBRARIES)
$(RESOURCES)
$(STARTUP_LIBRARY)
<<

$(LIBRARY) : make_main_dirs $(DLL) $(STARTUP_LIBRARY)
	@echo Binding %|feF to $(@F)
	$(AT)$(LIB) @<<
$(LIBFLAGS) /out:"$(LIBRARY)" 
$(STARTUP_LIBRARY)
<<
	
TARGET = $(DLL) $(LIBRARY)	
	
make_main_dirs:
	@if not exist "$(BINDIR)"      echo Making: "$(BINDIR)"      && mkdir "$(BINDIR)"
	@if not exist "$(INTDIR)"      echo Making: "$(INTDIR)"      && mkdir "$(INTDIR)"
	@if not exist "$(LIBDIR)"      echo Making: "$(LIBDIR)"      && mkdir "$(LIBDIR)"
	@if not exist "$(LISTING_DIR)" echo Making: "$(LISTING_DIR)" && mkdir "$(LISTING_DIR)"

!ENDIF	



#common targets

!INCLUDE common_targets.mak
