# Updated: 8th December 2003
# 
# Copyright (c) 2003, CRunTiny.org
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without modification,
# are permitted provided that the following conditions are met:
# 
# 1. Redistributions of source code must retain the above copyright notice, 
# this list of conditions and the following disclaimer. 
# 
# 2. Redistributions in binary form must reproduce the above copyright notice, 
# this list of conditions and the following disclaimer in the documentation 
# and/or other materials provided with the distribution. 
# 
# 3. Neither the names "CRunTiny" and "CRunTiny.org" nor the names of its 
# contributors must not be used to endorse or promote products derived from 
# this software without prior written permission. For written permission, please 
# contact cruntiny@cruntiny.org.
#  
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
# THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE 
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 
# OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
# OF THE POSSIBILITY OF SUCH DAMAGE.

# Purpose: This makefile creates the startup library
#
# Includes:
#
#   common_vars.mak     (Common variables: $(SRCDIR), $(DEFINES), etc.)
#   compiler.mak        (Causes inclusion of correct compiler makefile: vc6.mak, vc7.mak, vc71.mak)
#   startup_targets.mak (Startup target variables: $(OBJECTS), $(LIBRARIES))
#   common_targets.mak  (Common targets: all, makedir, etc.)




#directories

LIBDIR=$(CRUNTINY)\private\build\$(COMPILER)\$(PLATFORM)\$(LINKAGE)_$(THREADING)\$(CONFIG)
INTDIR=$(LIBDIR)\startup
LISTING_DIR=$(INTDIR)\Listings



#common variables

!INCLUDE common_vars.mak


#compiler dependent variables

!INCLUDE compiler.mak


#targets

!INCLUDE "startup_targets.mak"



LIBRARY="$(LIBDIR)\startup.lib"

$(LIBRARY) : make_startup_dirs $(OBJECTS)
	@echo Archiving $@
	$(AT)$(LIB) @<<
$(LIBFLAGS) /out:"$(LIBRARY)" 
$(OBJECTS)
<<
	
make_startup_dirs:
	@if not exist "$(INTDIR)"      echo Making: "$(INTDIR)"      && mkdir "$(INTDIR)"
	@if not exist "$(LIBDIR)"      echo Making: "$(LIBDIR)"      && mkdir "$(LIBDIR)"
	@if not exist "$(LISTING_DIR)" echo Making: "$(LISTING_DIR)" && mkdir "$(LISTING_DIR)"

TARGET = $(LIBRARY)

#common targets

!INCLUDE common_targets.mak
