/*

Copyright (c) 2003, CRunTiny.org
Copyright (c) 2001, Synesis Software Pty Ltd (http://synesis.com.au)
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, 
this list of conditions and the following disclaimer. 

2. Redistributions in binary form must reproduce the above copyright notice, 
this list of conditions and the following disclaimer in the documentation 
and/or other materials provided with the distribution. 

3. Neither the names "CRunTiny" and "CRunTiny.org" nor the names of its 
contributors must not be used to endorse or promote products derived from 
this software without prior written permission. For written permission, please 
contact cruntiny@cruntiny.org.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE 
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 
OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.

*/

#include <crtcore.h>
#include "platform.h"

#ifndef __SUPPRESS_STRNCPY


	extern "C"
	__CRUNTINY_EXPORT
	char *  __CRUNTINY_CRTCALL strncpy(char * const dest, char const * src, size_t count)
	{
		
		#ifdef __PLATFORM_HAS_STRNCPY
			
			return __Platform::StrNCpy(dest, src, count);

		#else

			/* This implementation derives from the Synesis Software implementation.
			 * Please concurrently report any bugs/issues to software@synesis.com.au.
			 */
			char	*dst;

			for(dst = dest; count && (*dst = *src) != '\0'; ++dst, ++src, --count)
			{}

			for(; count; *dst++ = '\0', --count)
			{}

			return dest;

		#endif
	}

#endif