/*
 *
 *
 * Updated: 1st March 2003

Copyright (c) 2003, CRunTiny.org
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, 
this list of conditions and the following disclaimer. 

2. Redistributions in binary form must reproduce the above copyright notice, 
this list of conditions and the following disclaimer in the documentation 
and/or other materials provided with the distribution. 

3. Neither the names "CRunTiny" and "CRunTiny.org" nor the names of its 
contributors must not be used to endorse or promote products derived from 
this software without prior written permission. For written permission, please 
contact cruntiny@cruntiny.org.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE 
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 
OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.

*/

#ifndef __COMPILER_ATEXIT_H
#define __COMPILER_ATEXIT_H

#include "compiler.h"

namespace __Compiler
{

	class AtExit
		: private __Platform::Mutex
	{
	protected:
#ifdef __CRUNTINY_MEMBER_CONSTANT_SUPPORT
		static const size_t s_ChunkSize = 32;
#else
		enum { s_ChunkSize = 32 };
#endif /* __CRUNTINY_MEMBER_CONSTANT_SUPPORT */

	public:
		typedef void (__CRUNTINY_CRTCALL * Function) ();

	// Construction
	public:
		__CRUNTINY_EXPORT AtExit();
		__CRUNTINY_EXPORT ~AtExit();
		
	// Operations
	public:
		__CRUNTINY_EXPORT int Append(Function func);
		__CRUNTINY_EXPORT void Invoke();

	// Implementation
	private:
		bool Grow();
		
	// Members
	private:
		Function	* m_pBegin;
		size_t		m_Size;
		Function	* m_pEnd;

	// Not to be implemented
	private:
		AtExit(AtExit const &);
		AtExit &operator =(AtExit const &);
	};

} // namespace __Compiler

#endif /* __COMPILER_INITTERM_H */
