/*

Copyright (c) 2003, CRunTiny.org
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, 
this list of conditions and the following disclaimer. 

2. Redistributions in binary form must reproduce the above copyright notice, 
this list of conditions and the following disclaimer in the documentation 
and/or other materials provided with the distribution. 

3. Neither the names "CRunTiny" and "CRunTiny.org" nor the names of its 
contributors must not be used to endorse or promote products derived from 
this software without prior written permission. For written permission, please 
contact cruntiny@cruntiny.org.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE 
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 
OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.

*/

#include <crtcore.h>
#include "compiler.h"
#include <process.h>
#include <new>
#include "thread.h"
#include "thread_data.h"

#ifdef _MT

extern "C"
__CRUNTINY_EXPORT uintptr_t __CRUNTINY_CRTCALL _beginthread (void (__CRUNTINY_CRTCALL * start_address) (void *),
										 unsigned stack_size, 
										 void * arglist)
{
	using __Compiler::Thread;

	Thread * pthread = new (std::nothrow) Thread();
	if (!pthread)
	{
		abort();
	}

	const uintptr_t ret = pthread->Run(start_address, stack_size, arglist);

	if (ret == -1)
	{
		delete pthread;
	}

	return ret;
}

extern "C"
__CRUNTINY_EXPORT void __CRUNTINY_CRTCALL _endthread(void)
{
	using __Compiler::Thread;
	using __Compiler::ThreadData;

	ThreadData * ptdata = ThreadData::GetInstance();
	Thread::Cleanup(ptdata, 0);
}

#endif //_MT
