/*

Copyright (c) 2003, CRunTiny.org
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, 
this list of conditions and the following disclaimer. 

2. Redistributions in binary form must reproduce the above copyright notice, 
this list of conditions and the following disclaimer in the documentation 
and/or other materials provided with the distribution. 

3. Neither the names "CRunTiny" and "CRunTiny.org" nor the names of its 
contributors must not be used to endorse or promote products derived from 
this software without prior written permission. For written permission, please 
contact cruntiny@cruntiny.org.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE 
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 
OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.

*/

#include <crtcore.h>
#include "call.h"


namespace __Compiler
{
#pragma warning(push)
#pragma warning(disable:4100) //these functions are in asm, of course I do not 'mention' the 
							  //parameters you moron!

		__declspec(naked)
		void CallMemberFunction(void * pObject, void * pfn,...)
		{
			__asm
			{
				pop         eax						// eax = ret addr
				pop         ecx						// ecx = pObject
				xchg        eax,dword ptr [esp]		// eax = pfn, ret addr on stack = our ret addr
				jmp         eax						// goto pfn 
			}
		}
#pragma warning(push)
#pragma warning(disable:4731) //yes I am going to modify ebp, please shut up
		__declspec(naked)
		void JumpToFunction(void * target, void * targetStack, void * targetEBP)
		{
			__asm
			{
				mov         eax,[esp + 0x4] // target
				mov         ebp,[esp + 0xC] // targetEBP
				mov         esp,[esp + 0x8] // targetStack
				jmp         eax
			}
		}


		__declspec(naked)
		void * __stdcall CallOnFrame0(void * addr, 
									  void * new_frame, 
									  void * temp1, //will hold old ebp
									  void * temp2) //will hold retaddr
		{
			__asm
			{
				mov [esp + 0Ch], ebp	//temp1 = ebp
				mov eax, [esp]			//eax = retaddr
				mov [esp + 10h], eax	//temp2 = retaddr
				add esp, 4				//remove retaddr from stack
				pop eax					//eax = addr
				pop ebp					//ebp = new_frame
				call eax				//call addr
				pop ebp					//restore ebp from temp1
				ret						//return to temp2
			}
		}

		__declspec(naked)
		void * __stdcall CallOnFrame2(void * addr, 
									  void * new_frame, 
									  void * arg1, 
									  void * arg2, 
									  void * temp1, //will hold old ebp
									  void * temp2) //will hold retaddr
		{
			__asm
			{
				mov [esp + 14h], ebp	//temp1 = ebp
				mov eax, [esp]			//eax = retaddr
				mov [esp + 18h], eax	//temp2 = retaddr
				add esp, 4				//remove retaddr from stack
				pop eax					//eax = addr
				pop ebp					//ebp = new_frame, arg1 on top of stack
				call eax				//call addr
				add esp, 8				//clean arg1 and arg2
				pop ebp					//restore ebp from temp1
				ret						//return to temp2
			}
		}
#pragma warning(pop) //enable 4731
#pragma warning(pop) //enable 4100
		
}






