/*
 * 
 *
 * Updated: 1st March 2003

Copyright (c) 2003, CRunTiny.org
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, 
this list of conditions and the following disclaimer. 

2. Redistributions in binary form must reproduce the above copyright notice, 
this list of conditions and the following disclaimer in the documentation 
and/or other materials provided with the distribution. 

3. Neither the names "CRunTiny" and "CRunTiny.org" nor the names of its 
contributors must not be used to endorse or promote products derived from 
this software without prior written permission. For written permission, please 
contact cruntiny@cruntiny.org.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE 
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 
OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.

*/

#ifndef __COMPILER_MODULE_DATA_H
#define __COMPILER_MODULE_DATA_H

#include "compiler.h"
#include "atexit.h"

namespace __Compiler
{

	class ModuleData 
	{
	public:
		static void __CRUNTINY_CRTCALL Init();
		static void __CRUNTINY_CRTCALL Term();
		static bool __CRUNTINY_CRTCALL Exist()
			{ return s_pModuleData != 0; }
		static ModuleData & __CRUNTINY_CRTCALL GetInstance()
			{ return *s_pModuleData; }

		AtExit & AtExitList()
			{ return m_AtExitList; }
	private:
		ModuleData()
		{}
		~ModuleData()
		{
			m_AtExitList.Invoke();
		}

	// Members
	private:
		AtExit				m_AtExitList;
		static ModuleData	* s_pModuleData;

	// Not to be implemented
	private:
		ModuleData(ModuleData const &);
		ModuleData & operator=(ModuleData const &);
	};

	
} // namespace __Compiler

#endif /* __COMPILER_MODULE_DATA_H */
