/*

Copyright (c) 2003, CRunTiny.org
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, 
this list of conditions and the following disclaimer. 

2. Redistributions in binary form must reproduce the above copyright notice, 
this list of conditions and the following disclaimer in the documentation 
and/or other materials provided with the distribution. 

3. Neither the names "CRunTiny" and "CRunTiny.org" nor the names of its 
contributors must not be used to endorse or promote products derived from 
this software without prior written permission. For written permission, please 
contact cruntiny@cruntiny.org.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE 
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 
OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.

*/

#ifndef __COMPILER_NEW_HANDLER_H
#define __COMPILER_NEW_HANDLER_H

#include "compiler.h"
#include <new>

namespace __Compiler
{

	class NewHandler
		: private __Platform::Mutex 
	{
	// Construction
	public:
		NewHandler():
			m_pHandler(Default)
		{}

	// Operations
	public:
#pragma warning(push)
#pragma warning(disable:4290)
		void Invoke() __CRUNTINY_THROW1(std::bad_alloc);
#pragma warning(pop)
		std::new_handler Set(std::new_handler handler) __CRUNTINY_THROW0();

	// Implementation
	private:
		static void __CRUNTINY_CRTCALL Default()
		{
			throw std::bad_alloc();
		}

	// Members
	private:
		std::new_handler m_pHandler;	

	// Not to be implemented
	private:
		NewHandler(NewHandler const &);
		NewHandler &operator =(NewHandler const &);
	};

} // namespace __Compiler


#endif /* __COMPILER_NEW_HANDLER_H */
