/*
 *
 * Updated: 8th December 2003

Copyright (c) 2003, CRunTiny.org
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, 
this list of conditions and the following disclaimer. 

2. Redistributions in binary form must reproduce the above copyright notice, 
this list of conditions and the following disclaimer in the documentation 
and/or other materials provided with the distribution. 

3. Neither the names "CRunTiny" and "CRunTiny.org" nor the names of its 
contributors must not be used to endorse or promote products derived from 
this software without prior written permission. For written permission, please 
contact cruntiny@cruntiny.org.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE 
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 
OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.

*/

#if defined(_MSC_VER) && \
	_MSC_VER == 1200
# pragma warning(disable : 4710)
#endif /* _MSC_VER == 1200 */

#include <crtcore.h>
#include "compiler.h"
#include <new>
#include "process_data.h"

namespace __Compiler
{
	ProcessData * ProcessData::s_pProcessData = 0;

	void __CRUNTINY_CRTCALL ProcessData::Init()
	{
		if (!s_pProcessData)
		{
			s_pProcessData = new (std::nothrow) ProcessData();

			if (!s_pProcessData)
			{
				abort();
			}
		}
		else
		{
			++(s_pProcessData->m_RefCount);
		}
	}

	__CRUNTINY_EXPORT void __CRUNTINY_CRTCALL ProcessData::Term()
	{
		const unsigned count = --(s_pProcessData->m_RefCount);

		if (count == 0)
		{
			delete s_pProcessData;
		}
	}

	__CRUNTINY_EXPORT ProcessData & __CRUNTINY_CRTCALL ProcessData::GetInstance()
	{
		return *s_pProcessData;
	}

} // namespace __Compiler
