/*

Copyright (c) 2003, CRunTiny.org
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, 
this list of conditions and the following disclaimer. 

2. Redistributions in binary form must reproduce the above copyright notice, 
this list of conditions and the following disclaimer in the documentation 
and/or other materials provided with the distribution. 

3. Neither the names "CRunTiny" and "CRunTiny.org" nor the names of its 
contributors must not be used to endorse or promote products derived from 
this software without prior written permission. For written permission, please 
contact cruntiny@cruntiny.org.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE 
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 
OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.

*/

#ifndef __COMPILER_THREAD_H
#define __COMPILER_THREAD_H

#include "compiler.h"

namespace __Compiler
{
#ifdef _MT
	class ThreadData;

	class Thread 
	{
	public:
		typedef void (__CRUNTINY_CRTCALL * CStartAddress) (void *);
		typedef unsigned (__stdcall * WinStartAddress) (void *);

		Thread():
			m_CStartAddress(0),
			m_WinStartAddress(0),
			m_ArgList(0)
		{
		}

		uintptr_t Run(CStartAddress start_address,
					  unsigned stack_size, 
					  void * arglist);
		uintptr_t Run(void * security, 
					  unsigned stack_size,
					  WinStartAddress start_address, 
					  void * arglist, 
					  unsigned initflag, 
					  unsigned * threadid);

		__CRUNTINY_DECLSPEC_NORETURN
		static void Cleanup(ThreadData * ptdata, unsigned retval);
	private:
		static unsigned long __stdcall Startup(void * arglist);
		
		CStartAddress m_CStartAddress;
		WinStartAddress m_WinStartAddress;
		void * m_ArgList;
	};
#endif  //_MT

} // namespace __Compiler



#endif /* __COMPILER_THREAD_H */
