/*
 *
 *
 * Updated: 29th April 2003

Copyright (c) 2003, CRunTiny.org
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, 
this list of conditions and the following disclaimer. 

2. Redistributions in binary form must reproduce the above copyright notice, 
this list of conditions and the following disclaimer in the documentation 
and/or other materials provided with the distribution. 

3. Neither the names "CRunTiny" and "CRunTiny.org" nor the names of its 
contributors must not be used to endorse or promote products derived from 
this software without prior written permission. For written permission, please 
contact cruntiny@cruntiny.org.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE 
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 
OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.

*/

#ifndef __CRUNTINY_CRT_CORE_H
#define __CRUNTINY_CRT_CORE_H


/* /////////////////////////////////////////////////////////////////////////////
 * function specifications
 */

/* Linkage class
 */

#ifdef __cplusplus

  #define __CRUNTINY_MOD_LINKAGE_C					extern "C"
  #define __CRUNTINY_GEN_STARTLINKAGE_C				extern "C" {
  #define __CRUNTINY_GEN_ENDLINKAGE_C				}
  #define __CRUNTINY_MOD_LINKAGE_CPP				extern "C++"
  #define __CRUNTINY_GEN_STARTLINKAGE_CPP			extern "C++" {
  #define __CRUNTINY_GEN_ENDLINKAGE_CPP				}

#else

  #define __CRUNTINY_MOD_LINKAGE_C					extern
  #define __CRUNTINY_GEN_STARTLINKAGE_C
  #define __CRUNTINY_GEN_ENDLINKAGE_C

#endif /* __cplusplus */

/* Storage class
 */

#ifdef _WINDLL

  #ifdef CRUNTINY_INSIDE_CRT

    #define __CRUNTINY_EXPORT						__declspec(dllexport) 

  #else
    
    #define __CRUNTINY_EXPORT						__declspec(dllimport) 

  #endif

#else

  #define __CRUNTINY_EXPORT

#endif /* _WINDLL */

#define __CRUNTINY_IMPORT	__declspec(dllimport)

/* Calling convention
 */

#if !defined(_MSC_VER) && \
    !defined(__cdecl)

  #define __CRUNTINY_CRTCALL

#else

  #define __CRUNTINY_CRTCALL						__cdecl

#endif /* !_MSC_VER && !__cdecl */

#if !defined(_W64)

  #if !defined(__midl) && \
      ( defined(_X86_) || \
        defined(_M_IX86)) && \
      _MSC_VER >= 1300

    #define _W64									__w64

  #else /* !__midl && ( _X86_ || _M_IX86) && _MSC_VER >= 1300 */

    #define _W64

  #endif

#endif /* !_W64 */


/* /////////////////////////////////////////////////////////////////////////////
 * Types
 */

#ifndef _UINTPTR_T_DEFINED

  #ifdef  _WIN64

    typedef unsigned __int64    uintptr_t;

  #else

    typedef _W64 unsigned int   uintptr_t;

  #endif /* _WIN64 */

	#define _UINTPTR_T_DEFINED
#endif /* _UINTPTR_T_DEFINED */


#ifndef _SIZE_T_DEFINED

  #ifdef  _WIN64

    typedef unsigned __int64    size_t;

  #else

    typedef _W64 unsigned int   size_t;

  #endif /* _WIN64 */
  
  #define _SIZE_T_DEFINED

#endif /* _SIZE_T_DEFINED */

#ifndef _PTRDIFF_T_DEFINED

  #ifdef _WIN64

    typedef __int64             ptrdiff_t;

  #else

    typedef _W64 int            ptrdiff_t;

  #endif /* _WIN64 */
  
  #define _PTRDIFF_T_DEFINED

#endif /* _PTRDIFF_T_DEFINED */


#ifndef _WCHAR_T_DEFINED

  typedef unsigned short wchar_t;

  #define _WCHAR_T_DEFINED

#endif /* _WCHAR_T_DEFINED */

#ifndef _WCTYPE_T_DEFINED

  typedef unsigned short wint_t;
  typedef unsigned short wctype_t;
  
  #define _WCTYPE_T_DEFINED

#endif /* _WCTYPE_T_DEFINED */


/* /////////////////////////////////////////////////////////////////////////////
 * Values
 */

#ifndef NULL

  #ifdef __cplusplus

    #define NULL									0

  #else

    #define NULL									((void *)0)

  #endif

#endif /* !NULL */

#ifdef __CRUNTINY_DECLSPEC_NORETURN_SUPPORTED
	#define __CRUNTINY_DECLSPEC_NORETURN __declspec(noreturn)
#else
	#define __CRUNTINY_DECLSPEC_NORETURN
#endif /* __CRUNTINY_DECLSPEC_NORETURN_SUPPORTED */


/* /////////////////////////////////////////////////////////////////////////////
 * Constraints
 */

#define	CRUNTINY_STATIC_ASSERT(_x)	{ typedef int ai[(_x)]; }

/* ////////////////////////////////////////////////////////////////////////// */

#if defined(CRUNTINY_INSIDE_CRT) && _MSC_VER >= 1310
	#pragma runtime_checks( "", off )
#endif


#endif /* __CRUNTINY_CRT_CORE_H */
