/*
 * Updated: 8th December 2003

Copyright (c) 2003, CRunTiny.org
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, 
this list of conditions and the following disclaimer. 

2. Redistributions in binary form must reproduce the above copyright notice, 
this list of conditions and the following disclaimer in the documentation 
and/or other materials provided with the distribution. 

3. Neither the names "CRunTiny" and "CRunTiny.org" nor the names of its 
contributors must not be used to endorse or promote products derived from 
this software without prior written permission. For written permission, please 
contact cruntiny@cruntiny.org.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE 
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 
OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.

*/

#ifndef __CRUNTINY_STRING_H
#define __CRUNTINY_STRING_H


#ifdef  __cplusplus
extern "C" {
#endif /* __cplusplus */

__CRUNTINY_EXPORT void *  __CRUNTINY_CRTCALL memmove(void *, void const *, size_t);
__CRUNTINY_EXPORT int     __CRUNTINY_CRTCALL memcmp(void const *, void const *, size_t);
__CRUNTINY_EXPORT void * __CRUNTINY_CRTCALL memset(void *, int, size_t);
__CRUNTINY_EXPORT void *  __CRUNTINY_CRTCALL memcpy(void *, void const *, size_t);
/* 
__CRUNTINY_EXPORT void *  __CRUNTINY_CRTCALL _memccpy(void *, void const *, int, size_t);
__CRUNTINY_EXPORT void *  __CRUNTINY_CRTCALL memchr(void const *, int, size_t);
__CRUNTINY_EXPORT int     __CRUNTINY_CRTCALL _memicmp(void const *, void const *, size_t);
*/

__CRUNTINY_EXPORT char *  __CRUNTINY_CRTCALL strcpy(char *, char const *);
__CRUNTINY_EXPORT char *  __CRUNTINY_CRTCALL strcat(char *, char const *);
__CRUNTINY_EXPORT int     __CRUNTINY_CRTCALL strcmp(char const *, char const *);
__CRUNTINY_EXPORT size_t  __CRUNTINY_CRTCALL strlen(char const *);
__CRUNTINY_EXPORT char *  __CRUNTINY_CRTCALL strncpy(char *, char const *, size_t);
__CRUNTINY_EXPORT int     __CRUNTINY_CRTCALL _strcmpi(char const *, char const *);
__CRUNTINY_EXPORT int     __CRUNTINY_CRTCALL _stricmp(char const *, char const *);
__CRUNTINY_EXPORT char *  __CRUNTINY_CRTCALL _strdup(char const *);

#define _strcmpi _stricmp

/*
char *  __CRUNTINY_CRTCALL _strset(char *, int);
__CRUNTINY_EXPORT char *  __CRUNTINY_CRTCALL strchr(char const *, int);
__CRUNTINY_EXPORT int     __CRUNTINY_CRTCALL strcoll(char const *, char const *);
__CRUNTINY_EXPORT int     __CRUNTINY_CRTCALL _stricoll(char const *, char const *);
__CRUNTINY_EXPORT int     __CRUNTINY_CRTCALL _strncoll(char const *, char const *, size_t);
__CRUNTINY_EXPORT int     __CRUNTINY_CRTCALL _strnicoll(char const *, char const *, size_t);
__CRUNTINY_EXPORT size_t  __CRUNTINY_CRTCALL strcspn(char const *, char const *);

__CRUNTINY_EXPORT char *  __CRUNTINY_CRTCALL _strerror(char const *);
__CRUNTINY_EXPORT char *  __CRUNTINY_CRTCALL strerror(int);
__CRUNTINY_EXPORT char *  __CRUNTINY_CRTCALL _strlwr(char *);
__CRUNTINY_EXPORT char *  __CRUNTINY_CRTCALL strncat(char *, char const *, size_t);
__CRUNTINY_EXPORT int     __CRUNTINY_CRTCALL strncmp(char const *, char const *, size_t);
__CRUNTINY_EXPORT int     __CRUNTINY_CRTCALL _strnicmp(char const *, char const *, size_t);

__CRUNTINY_EXPORT char *  __CRUNTINY_CRTCALL _strnset(char *, int, size_t);
__CRUNTINY_EXPORT char *  __CRUNTINY_CRTCALL strpbrk(char const *, char const *);
__CRUNTINY_EXPORT char *  __CRUNTINY_CRTCALL strrchr(char const *, int);
__CRUNTINY_EXPORT char *  __CRUNTINY_CRTCALL _strrev(char *);
__CRUNTINY_EXPORT size_t  __CRUNTINY_CRTCALL strspn(char const *, char const *);
__CRUNTINY_EXPORT char *  __CRUNTINY_CRTCALL strstr(char const *, char const *);
__CRUNTINY_EXPORT char *  __CRUNTINY_CRTCALL strtok(char *, char const *);
__CRUNTINY_EXPORT char *  __CRUNTINY_CRTCALL _strupr(char *);
__CRUNTINY_EXPORT size_t  __CRUNTINY_CRTCALL strxfrm (char *, char const *, size_t);
*/


#ifndef _WSTRING_DEFINED

/* wide function prototypes, also declared in wchar.h  */

__CRUNTINY_EXPORT wchar_t * __CRUNTINY_CRTCALL wcscat(wchar_t *, wchar_t const *);
__CRUNTINY_EXPORT int __CRUNTINY_CRTCALL wcscmp(wchar_t const *, wchar_t const *);
__CRUNTINY_EXPORT wchar_t * __CRUNTINY_CRTCALL wcscpy(wchar_t *, wchar_t const *);
__CRUNTINY_EXPORT size_t __CRUNTINY_CRTCALL wcslen(wchar_t const *);
__CRUNTINY_EXPORT wchar_t * __CRUNTINY_CRTCALL wcsncpy(wchar_t *, wchar_t const *, size_t);
__CRUNTINY_EXPORT wchar_t * __CRUNTINY_CRTCALL _wcsdup(wchar_t const *);
__CRUNTINY_EXPORT int __CRUNTINY_CRTCALL _wcsicmp(wchar_t const *, wchar_t const *);

/*
__CRUNTINY_EXPORT wchar_t * __CRUNTINY_CRTCALL wcschr(wchar_t const *, wchar_t);
__CRUNTINY_EXPORT size_t __CRUNTINY_CRTCALL wcscspn(wchar_t const *, wchar_t const *);
__CRUNTINY_EXPORT wchar_t * __CRUNTINY_CRTCALL wcsncat(wchar_t *, wchar_t const *, size_t);
__CRUNTINY_EXPORT int __CRUNTINY_CRTCALL wcsncmp(wchar_t const *, wchar_t const *, size_t);
__CRUNTINY_EXPORT wchar_t * __CRUNTINY_CRTCALL wcspbrk(wchar_t const *, wchar_t const *);
__CRUNTINY_EXPORT wchar_t * __CRUNTINY_CRTCALL wcsrchr(wchar_t const *, wchar_t);
__CRUNTINY_EXPORT size_t __CRUNTINY_CRTCALL wcsspn(wchar_t const *, wchar_t const *);
__CRUNTINY_EXPORT wchar_t * __CRUNTINY_CRTCALL wcsstr(wchar_t const *, wchar_t const *);
__CRUNTINY_EXPORT wchar_t * __CRUNTINY_CRTCALL wcstok(wchar_t *, wchar_t const *);
__CRUNTINY_EXPORT wchar_t * __CRUNTINY_CRTCALL _wcserror(int);
__CRUNTINY_EXPORT wchar_t * __CRUNTINY_CRTCALL __wcserror(wchar_t const *);
__CRUNTINY_EXPORT int __CRUNTINY_CRTCALL _wcsnicmp(wchar_t const *, wchar_t const *, size_t);
__CRUNTINY_EXPORT wchar_t * __CRUNTINY_CRTCALL _wcsnset(wchar_t *, wchar_t, size_t);
__CRUNTINY_EXPORT wchar_t * __CRUNTINY_CRTCALL _wcsrev(wchar_t *);
__CRUNTINY_EXPORT wchar_t * __CRUNTINY_CRTCALL _wcsset(wchar_t *, wchar_t);

__CRUNTINY_EXPORT wchar_t * __CRUNTINY_CRTCALL _wcslwr(wchar_t *);
__CRUNTINY_EXPORT wchar_t * __CRUNTINY_CRTCALL _wcsupr(wchar_t *);
__CRUNTINY_EXPORT size_t __CRUNTINY_CRTCALL wcsxfrm(wchar_t *, wchar_t const *, size_t);
__CRUNTINY_EXPORT int __CRUNTINY_CRTCALL wcscoll(wchar_t const *, wchar_t const *);
__CRUNTINY_EXPORT int __CRUNTINY_CRTCALL _wcsicoll(wchar_t const *, wchar_t const *);
__CRUNTINY_EXPORT int __CRUNTINY_CRTCALL _wcsncoll(wchar_t const *, wchar_t const *, size_t);
__CRUNTINY_EXPORT int __CRUNTINY_CRTCALL _wcsnicoll(wchar_t const *, wchar_t const *, size_t);
*/

#define _WSTRING_DEFINED
#endif


#ifdef  __cplusplus
}
#endif /* __cplusplus */

#endif /* __CRUNTINY_STRING_H */

