@echo off
if (%CRUNTINY_ROOT%) == () echo "You need to have the CRUNTINY_ROOT environment variable defined to use CStdioTiny" && echo "  This needs to be the CRunTiny directoy that is a peer to the CStdioTiny directory, e.g. c:\cruntiny\1.0\cruntiny" && goto end

rem cd
if (%CSTDIOTINY_ROOT%) == () set CSTDIOTINY_ROOT=..

echo Building CStdioTiny (located in %CRUNTINY_ROOT%)

@echo off
echo ͻ
echo                   Starting Build of CStdioTiny                               
echo                                                                              
echo.

echo Detecting compiler version...
cl /nologo version.cpp > nul:
for /F "usebackq delims==" %%i IN (`version`) DO set VERS=%%i 
del version.exe version.obj

if %VERS%==1200 set COMPILER=VC6
if %VERS%==1300 set COMPILER=VC7
if %VERS%==1310 set COMPILER=VC7.1

echo COMPILER=%COMPILER%

set PLATFORM=Win32

setlocal
echo ͻ
echo                   Static Single-Threaded
set LINKAGE=Static
set THREADING=ST
nmake /nologo /f makefile %*
echo                   End of Static Single-Threaded
echo ͼ
endlocal

setlocal
echo ͻ
echo                   Static Multi-Threaded
set LINKAGE=Static
set THREADING=MT
nmake /nologo /f makefile %*
echo                   End of Static Multi-Threaded
echo ͼ
endlocal

setlocal
echo ͻ
echo                   Dynamic Multi-Threaded
set LINKAGE=Dynamic
set THREADING=MT
rem nmake /nologo /f makefile %*
echo                                                                              
echo          CStdioTiny is not currently available in a Dynamic build            
echo                                                                              
echo                   End of Dynamic Multi-Threaded
echo ͼ
endlocal

echo.
echo                                                                              
echo                   Finished Build of CStdioTiny                               
echo ͼ

:end
