/* /////////////////////////////////////////////////////////////////////////////
 * File:        cstdiotiny_internal.h
 *
 * Purpose:     Internal header for CStdioTiny
 *
 * Created      17th July 2003
 * Updated:     8th December 2003
 *
 * Copyright:   cruntiny.org, (c) 2003. All rights reserved.
 *
 * Home:        www.cruntiny.org
 *
 * ////////////////////////////////////////////////////////////////////////// */


#ifdef __CSTDIOTINY_INCL_H_CSTDIOTINY_INTERNAL
# error Cannot include CStdioTiny.h more than once
#else
# define __CSTDIOTINY_INCL_H_CSTDIOTINY_INTERNAL

/* /////////////////////////////////////////////////////////////////////////////
 * Includes
 */

#include <cstdiotiny.h>
#include <stdarg.h>

/* /////////////////////////////////////////////////////////////////////////////
 * Typedefs
 */

typedef	char							_byte_t;
typedef	int								_bool_t;
typedef	int								_win32_bool_t;
typedef	unsigned long					_win32_dword_t;
typedef	unsigned long					_win32_error_t;
typedef	int								_cst_error_t;

/* /////////////////////////////////////////////////////////////////////////////
 * CStdioTiny functions
 */

extern void cruntiny_set_errno_from_Win32(_win32_error_t );
extern void cruntiny_set_errno(_cst_error_t err);

extern void cruntiny_assert(char const *);

/* /////////////////////////////////////////////////////////////////////////////
 * Win32 functions
 */

extern void				*__CSTDIOTINY_WIN32STDCALL GlobalAlloc(unsigned, size_t);
extern void				*__CSTDIOTINY_WIN32STDCALL GlobalFree(void *);
extern char				*__CSTDIOTINY_WIN32STDCALL CharLowerA(char*);
extern wchar_t			*__CSTDIOTINY_WIN32STDCALL CharLowerW(wchar_t*);
extern char				*__CSTDIOTINY_WIN32STDCALL CharUpperA(char*);
extern wchar_t			*__CSTDIOTINY_WIN32STDCALL CharUpperW(wchar_t*);
extern _win32_error_t	__CSTDIOTINY_WIN32STDCALL GetLastError(void);
extern _win32_bool_t	__CSTDIOTINY_WIN32STDCALL SetCurrentDirectoryA(char const *);
extern _win32_dword_t	__CSTDIOTINY_WIN32STDCALL GetCurrentDirectoryA(unsigned long, char const *);
extern int				__CSTDIOTINY_WIN32CRTCALL wsprintfA(char *, char const *, ...);
extern int				__CSTDIOTINY_WIN32STDCALL lstrlenA(char const *);
extern int				__CSTDIOTINY_WIN32STDCALL CloseHandle(void *);
extern int				__CSTDIOTINY_WIN32STDCALL FlushFileBuffers(void *);
extern void *			__CSTDIOTINY_WIN32STDCALL GetStdHandle(unsigned long );
extern _win32_dword_t	__CSTDIOTINY_WIN32STDCALL GetLastError(void);
extern void				__CSTDIOTINY_WIN32STDCALL OutputDebugStringA(char const *);
extern _win32_bool_t	__CSTDIOTINY_WIN32STDCALL WriteConsoleA(void *hFile, void const *lpBuffer, unsigned long nNumberOfCharsToWrite, unsigned long *lpNumberOfCharsWritten, void *);
extern _win32_bool_t	__CSTDIOTINY_WIN32STDCALL WriteConsoleW(void *hFile, void const *lpBuffer, unsigned long nNumberOfCharsToWrite, unsigned long *lpNumberOfCharsWritten, void *);
extern _win32_bool_t	__CSTDIOTINY_WIN32STDCALL WriteFile(void *hFile, void const *lpBuffer, unsigned long nNumberOfBytesToWrite, unsigned long *lpNumberOfBytesWritten, void *);
extern int				__CSTDIOTINY_WIN32STDCALL wvsprintfA(char *, char const *, va_list);
extern int				__CSTDIOTINY_WIN32STDCALL wvsprintfW(wchar_t *, wchar_t const *, va_list);

extern _win32_dword_t	__CSTDIOTINY_WIN32STDCALL GetCurrentProcessId(void);

extern void				*__CSTDIOTINY_WIN32STDCALL VirtualAlloc(void *, _win32_dword_t, _win32_dword_t, _win32_dword_t);
extern _win32_bool_t	__CSTDIOTINY_WIN32STDCALL VirtualFree(void *, _win32_dword_t, _win32_dword_t);

/* ////////////////////////////////////////////////////////////////////////// */

#endif /* __CSTDIOTINY_INCL_H_CSTDIOTINY_INTERNAL */

/* ////////////////////////////////////////////////////////////////////////// */
