/* /////////////////////////////////////////////////////////////////////////////
 * File:        synesis.h
 *
 * Purpose:     Internal header to enable use of Synesis components for CStdioTiny
 *
 * Created      10th July 2003
 * Updated:     17th July 2003
 *
 * Copyright:   cruntiny.org, (c) 2003. All rights reserved.
 *
 * Home:        www.cruntiny.org
 *
 * ////////////////////////////////////////////////////////////////////////// */


#ifdef __CSTDIOTINY_INCL_H_SYNESIS
 #error Cannot include CStdioTiny.h more than once
#else
 #define __CSTDIOTINY_INCL_H_SYNESIS

#ifndef _MSC_VER
 #error This shortcut header is only valid for Microsoft Visual C++ (or compatible) compilers
#endif /* !_MSC_VER */


#define	_SYNSOFT_INCL_H_MLBASE
#define	_SYNSOFT_INCL_H_MWBASE
#define	_SYNSOFT_INCL_H_MLALIGN
#define	_SYNSOFT_INCL_H_MEDBGTRC

#define	_SYNSOFT_INCL_H_SWRN003O
#define	_SYNSOFT_INCL_H_SWRN003U
#define	_SYNSOFT_INCL_H_SWRN005O
#define	_SYNSOFT_INCL_H_SWRN005U

#define __SYNSOFT_VAL_COMPILER_BORLAND      (0x1000)
#define __SYNSOFT_VAL_COMPILER_DECC         (0x5000)
#define __SYNSOFT_VAL_COMPILER_DECCXX       (0x3000)
#define __SYNSOFT_VAL_COMPILER_DMC          (0x8000)
#define __SYNSOFT_VAL_COMPILER_GNUC         (0x4000)
#define __SYNSOFT_VAL_COMPILER_MWERKS       (0x9000)
#define __SYNSOFT_VAL_COMPILER_MSVC         (0x2000)
#define __SYNSOFT_VAL_COMPILER_WATCOM       (0x7000)
#define __SYNSOFT_VAL_COMPILER_XLC          (0x6000)
#ifdef __INTEL_COMPILER
 #define __SYNSOFT_DVS_COMPILER				__SYNSOFT_VAL_COMPILER_INTEL
#elif defined(_MSC_VER)
 #define __SYNSOFT_DVS_COMPILER				__SYNSOFT_VAL_COMPILER_MSVC
#else
 #error Compiler not supported
#endif /* compiler */
#define	false								(0)
#define	true								(1)

#define	__SYNSOFT_DVS_OS_BITSIZE			32
#define	IntP_size							sizeof(UIntP)

#define _mP(_x)								_x*

#define	SYFNCDECL(x)						x __CSTDIOTINY_CRTCALL
#define	SYFNCDECLREF(x)						x *__CSTDIOTINY_CRTCALL
#define	mT(x)								x
#define	SyCastConst(x, y)					(x)y
#define	SyCastStatic(x, y)					(x)y

#define SyAlignUpToVoid(x)					SyAlignUpVoid(x, IntP_size)
#define SyAlignUpVoid(x, y)					SyAlignUpVar(x, PVoid, y)
#define SyAlignUpVar(var, type, size)		do { var = (type)(((UIntP)var + (size - 1)) & ~((UIntP)(size - 1))); } while(0)

#define SyAlignDownToVoid(x)				SyAlignDownVoid(x, IntP_size)
#define SyAlignDownVoid(x, y)				SyAlignDownVar(x, PVoid, y)
#define SyAlignDownVar(var, type, size)		do { var = (type)(((UIntP)var) & ~((UIntP)(size - 1))); } while(0)


typedef	signed int							SInt32;
typedef	unsigned int						UInt32;
typedef	signed short						SInt16;
typedef	unsigned short						UInt16;
typedef	UInt32								UIntP;
typedef	int									Int;
typedef	unsigned char						Byte;
typedef	int									Bool;
typedef	Byte								*PByte;
typedef	size_t								Size;
typedef	void								*PVoid;

/* ////////////////////////////////////////////////////////////////////////// */

#endif /* __CSTDIOTINY_INCL_H_SYNESIS */

/* ////////////////////////////////////////////////////////////////////////// */
