/* /////////////////////////////////////////////////////////////////////////////
 * File:        ctype.c
 *
 * Purpose:     
 *
 * Created      10th July 2003
 * Updated:     8th December 2003
 *
 * Copyright:   cruntiny.org, (c) 2003. All rights reserved.
 *
 * Home:        www.cruntiny.org
 *
 * ////////////////////////////////////////////////////////////////////////// */


#include "cstdiotiny_internal.h"

/* /////////////////////////////////////////////////////////////////////////////
 * Function declarations
 */

extern int __CSTDIOTINY_CRTCALL __crt_isdigit(int ch);
extern int __CSTDIOTINY_CRTCALL __crt_isspace(int ch);
extern int __CSTDIOTINY_CRTCALL __crt_isalnum(int ch);

/* /////////////////////////////////////////////////////////////////////////////
 * Statics
 */

static int	_ctype_characters_dec_hex[] = 
{
		'0'
	,	'1'
	,	'2'
	,	'3'
	,	'4'
	,	'5'
	,	'6'
	,	'7'
	,	'8'
	,	'9'
	,	'a'
	,	'b'
	,	'c'
	,	'd'
	,	'e'
	,	'f'
	,	'A'
	,	'B'
	,	'C'
	,	'D'
	,	'E'
	,	'F'
};

/* /////////////////////////////////////////////////////////////////////////////
 * isdigit()
 */

int __CSTDIOTINY_CRTCALL __crt_isdigit(int ch)
{
#if 1
	int	*begin	=	_ctype_characters_dec_hex;
	int *end	=	begin + 10;

	for(; begin != end; ++begin)
	{
		if(ch == *begin)
		{
			return 1;
		}
	}

	return 0;
#else
	switch(ch)
	{
		case	'0':
		case	'2':
		case	'3':
		case	'4':
		case	'5':
		case	'6':
		case	'7':
		case	'8':
		case	'9':
			return 1;
		default:
			return 0;
	}
#endif /* 0 */
}

int __CSTDIOTINY_CRTCALL isdigit(int ch)
{
	return __crt_isdigit(ch);
}

#if 0
int __CSTDIOTINY_CRTCALL iswdigit(wint_t ch)
{
	return __crt_isdigit(ch);
}
#endif /* 0 */

/* /////////////////////////////////////////////////////////////////////////////
 * isxdigit()
 */

int __CSTDIOTINY_CRTCALL __crt_isxdigit(int ch)
{
#if 1
	int	*begin	=	_ctype_characters_dec_hex;
	int *end	=	begin + 22;

	for(; begin != end; ++begin)
	{
		if(ch == *begin)
		{
			return 1;
		}
	}

	return 0;
#else
	switch(ch)
	{
		case	'a':
		case	'b':
		case	'c':
		case	'd':
		case	'e':
		case	'f':
		case	'A':
		case	'B':
		case	'C':
		case	'D':
		case	'E':
		case	'F':
			return 1;
		default:
			return __crt_isdigit(ch);
	}
#endif /* 0 */
}

int __CSTDIOTINY_CRTCALL isxdigit(int ch)
{
	return __crt_isxdigit(ch);
}

#if 0
int __CSTDIOTINY_CRTCALL iswxdigit(wint_t ch)
{
	return __crt_isxdigit(ch);
}
#endif /* 0 */

#ifndef __CRUNTINY_CRT_CORE_H

/* /////////////////////////////////////////////////////////////////////////////
 * isalpha()
 */

int __CSTDIOTINY_CRTCALL __crt_isalpha(int ch)
{
	return (ch >= 'a' && ch <= 'z') || (ch >= 'A' && ch <= 'Z');
}

int __CSTDIOTINY_CRTCALL isalpha(int ch)
{
	return __crt_isalpha(ch);
}

#if 0
int __CSTDIOTINY_CRTCALL iswalpha(wint_t ch)
{
	return __crt_isalpha(ch);
}
#endif /* 0 */

/* /////////////////////////////////////////////////////////////////////////////
 * isalnum()
 */

int __CSTDIOTINY_CRTCALL __crt_isalnum(int ch)
{
	return __crt_isalpha(ch) || __crt_isdigit(ch);
}

int __CSTDIOTINY_CRTCALL isalnum(int ch)
{
	return __crt_isalnum(ch);
}

#if 0
int __CSTDIOTINY_CRTCALL iswalnum(wint_t ch)
{
	return __crt_isalnum(ch);
}
#endif /* 0 */

#endif /* !__CRUNTINY_CRT_CORE_H */

/* /////////////////////////////////////////////////////////////////////////////
 * isascii()
 */

int __CSTDIOTINY_CRTCALL __crt_isascii(int ch)
{
	return ch < 0x80;
}

int __CSTDIOTINY_CRTCALL isascii(int ch)
{
	return __crt_isascii(ch);
}

#if 0
int __CSTDIOTINY_CRTCALL iswascii(wint_t ch)
{
	return __crt_isascii(ch);
}
#endif /* 0 */

/* /////////////////////////////////////////////////////////////////////////////
 * iscntrl()
 */

int __CSTDIOTINY_CRTCALL __crt_iscntrl(int ch)
{
	return ch <= 0x1F || ch == 0x7F;
}

int __CSTDIOTINY_CRTCALL iscntrl(int ch)
{
	return __crt_iscntrl(ch);
}

#if 0
int __CSTDIOTINY_CRTCALL iswcntrl(wint_t ch)
{
	return __crt_iscntrl(ch);
}
#endif /* 0 */

/* /////////////////////////////////////////////////////////////////////////////
 * isspace()
 */

int __CSTDIOTINY_CRTCALL __crt_isspace(int ch)
{
	return ch == ' ' || !(ch < 0x09 || ch > 0x0D);
}

int __CSTDIOTINY_CRTCALL isspace(int ch)
{
	return __crt_isspace(ch);
}

#if 0
int __CSTDIOTINY_CRTCALL iswspace(wint_t ch)
{
	return __crt_isspace(ch);
}
#endif /* 0 */

/* /////////////////////////////////////////////////////////////////////////////
 * isprint()
 */

int __CSTDIOTINY_CRTCALL __crt_isprint(int ch)
{
	return (ch >= 0x20 && ch <= 0x7E);
}

int __CSTDIOTINY_CRTCALL isprint(int ch)
{
	return __crt_isprint(ch);
}

#if 0
int __CSTDIOTINY_CRTCALL iswprint(wint_t ch)
{
	return __crt_isprint(ch);
}
#endif /* 0 */

/* /////////////////////////////////////////////////////////////////////////////
 * ispunct()
 */

int __CSTDIOTINY_CRTCALL __crt_ispunct(int ch)
{
	return __crt_isprint(ch) && !(__crt_isspace(ch) || __crt_isalnum(ch));
}

int __CSTDIOTINY_CRTCALL ispunct(int ch)
{
	return __crt_ispunct(ch);
}

#if 0
int __CSTDIOTINY_CRTCALL iswpunct(wint_t ch)
{
	return __crt_ispunct(ch);
}
#endif /* 0 */

/* /////////////////////////////////////////////////////////////////////////////
 * isgraph()
 */

int __CSTDIOTINY_CRTCALL __crt_isgraph(int ch)
{
	return __crt_isprint(ch) && ch != ' ';
}

int __CSTDIOTINY_CRTCALL isgraph(int ch)
{
	return __crt_isgraph(ch);
}

#if 0
int __CSTDIOTINY_CRTCALL iswgraph(wint_t ch)
{
	return __crt_isgraph(ch);
}
#endif /* 0 */

/* /////////////////////////////////////////////////////////////////////////////
 * tolower()
 */

int __CSTDIOTINY_CRTCALL tolower(int c)
{
	return (int)CharLowerA((char*)(c & 0xffff));
}

wint_t __CSTDIOTINY_CRTCALL towlower(wint_t c)
{
	return (wint_t)CharLowerW((wchar_t*)(c & 0xffff));
}

/* /////////////////////////////////////////////////////////////////////////////
 * toupper()
 */

int __CSTDIOTINY_CRTCALL toupper(int c)
{
	return (int)CharUpperA((char*)(c & 0xffff));
}

wint_t __CSTDIOTINY_CRTCALL towupper(wint_t c)
{
	return (wint_t)CharUpperW((wchar_t*)(c & 0xffff));
}

/* ////////////////////////////////////////////////////////////////////////// */
