/* /////////////////////////////////////////////////////////////////////////////
 * File:        stdlib.c
 *
 * Purpose:     
 *
 * Created      10th July 2003
 * Updated:     8th December 2003
 *
 * Copyright:   cruntiny.org, (c) 2003. All rights reserved.
 *
 * Home:        www.cruntiny.org
 *
 * ////////////////////////////////////////////////////////////////////////// */


#include "cstdiotiny_internal.h"
#include <stdlib.h>
#include <string.h>

/* ////////////////////////////////////////////////////////////////////////// */

void * __CSTDIOTINY_CRTCALL calloc(size_t num, size_t size)
{
	void	*pv	=	malloc((size = size * num));

	return (NULL == pv) ? NULL : memset(pv, 0, size);
}

/* ////////////////////////////////////////////////////////////////////////// */

int __CSTDIOTINY_CRTCALL atoi(char const *s)
{
	return strtol(s, NULL, 10);
}

long   __CSTDIOTINY_CRTCALL atol(char const *s)
{
	return strtol(s, NULL, 10);
}

char * __CSTDIOTINY_CRTCALL itoa(int i, char *buffer, int radix)
{
	switch(radix)
	{
		case	10:
			wsprintfA(buffer, "%d", i);
			break;
		case	16:
			wsprintfA(buffer, "%x", i);
			break;
		default:
			cruntiny_assert("itoa() supports only bases 10 and 16");
			break;
	}

	return buffer;
}

char * __CSTDIOTINY_CRTCALL ltoa(long i, char *buffer, int radix)
{
	return itoa(i, buffer, radix);
}

/* ////////////////////////////////////////////////////////////////////////// */

#include "synesis.h"

#include <ctype.h>

#undef isdigit
#define	isdigit								__crt_isdigit
#undef iswdigit
#define	iswdigit							__crt_isdigit

#undef isspace
#define	isspace								__crt_isspace
#undef iswspace
#define	iswspace							__crt_isspace

/* Each of these is 9KB, so there is probably large scope for trimming */

#include "synesis/strtol.c"
#include "synesis/strtoul.c"

/* ////////////////////////////////////////////////////////////////////////// */

