
/*
 * Updated: 15th July 2003
 */

#ifndef _SYNSOFT_INCL_H_MLBASE
 #include <MLBase.h>
#endif /* !_SYNSOFT_INCL_H_MLBASE */
#ifndef _SYNSOFT_INCL_H_MWBASE
 #include <MWBase.h>
#endif /* !_SYNSOFT_INCL_H_MWBASE */
#ifndef _SYNSOFT_INCL_H_MLMEMORY
 #include <MLMemory.h>
#endif /* !_SYNSOFT_INCL_H_MLMEMORY */
#ifndef _SYNSOFT_INCL_H_MWVER
 #include <MWVer.h>
#endif /* !_SYNSOFT_INCL_H_MWVER */

/* stricmp functions.
 */

SYFNCDECL(Int) stricmp(char const *str1, char const *str2)
{
    return lstrcmpiA(str1, str2);
}

SYFNCDECL(Int) wcsicmp(wchar_t const *str1, wchar_t const *str2)
{
    Int ret;

	if(IsWinNT())
	{
		ret = lstrcmpiW(str1, str2);
	}
	else
	{
		/* Now need to allocate two strings to do the comparison. */
		Int		cch1	=	1 + wcslen(str1);
		Int		cch2	=	1 + wcslen(str2);
		char	*p1		=	SyCastRaw(char*, Mem_Alloc(cch1));
		char	*p2		=	SyCastRaw(char*, Mem_Alloc(cch2));

		WideCharToMultiByte(0, 0, str1, -1, p1, cch1, NULL, NULL);
		WideCharToMultiByte(0, 0, str2, -1, p2, cch2, NULL, NULL);

		ret = lstrcmpiA(p1, p2);

		Mem_Free(p1);
		Mem_Free(p2);
	}

    return ret;
}
